<?php

use Cake\ORM\TableRegistry;
use Migrations\AbstractMigration;
use Refae\Model\Entity\Document;

class CreateCategoriesDocuments extends AbstractMigration
{
    /**
     * Migrate Up
     *
     * @return void
     * @throws Exception
     */
    public function up()
    {
        $Documents = TableRegistry::getTableLocator()->get("Documents");
        $conn = $Documents->getConnection();
        $conn->begin();

        $table = $this->table('categories_documents');
        $table->addColumn('category_id', 'integer', [
            'default' => null,
            'limit' => 11,
            'null' => false,
        ]);
        $table->addColumn('document_id', 'integer', [
            'default' => null,
            'limit' => 11,
            'null' => false,
        ]);
        $table->create();
        $CategoriesDocuments = TableRegistry::getTableLocator()->get("CategoriesDocuments");

        $lastIds = [];
        /** @var Document $document */
        foreach ($Documents->find()->all()->toArray() as $document) {
            $identifiant = $document->get('identifiant');
            if (!isset($lastIds[$identifiant])) {
                $lastIds[$identifiant] = $Documents->find()
                    ->select(['id'])
                    ->where(['identifiant' => $identifiant])
                    ->order(['version' => 'desc'])
                    ->firstOrFail()
                    ->get('id')
                ;
            }
            $entity = $CategoriesDocuments->newEntity([
                'category_id' => $document->get('categorie_id'),
                'document_id' => $lastIds[$identifiant],
            ]);
            $CategoriesDocuments->save($entity);
        }

        $conn->commit();
    }

    /**
     * Migrate Down
     *
     * @return void
     */
    public function down()
    {
        $table = $this->table('categories_documents');
        $table->drop();
    }
}
