<?php

use Migrations\AbstractMigration;

class AddStatusToDocuments extends AbstractMigration
{
    /**
     * Migrate Up
     *
     * @return void
     * @throws Exception
     */
    public function up()
    {
        $table = $this->table('documents');
        $table->addColumn('status', 'string', [
            'default' => 'actif',
            'limit' => 255,
            'null' => false,
        ]);
        $table->update();

        $table->changeColumn('status', 'string', [
            'default' => null,
            'limit' => 255,
            'null' => false,
        ]);
        $table->update();
    }

    /**
     * Migrate Down
     *
     * @return void
     */
    public function down()
    {
        $table = $this->table('documents');
        $table->removeColumn('status');
        $table->update();
    }
}
