<?php

use Cake\ORM\TableRegistry;
use Migrations\AbstractMigration;
use Refae\Model\Table\UsersTable;

class AddFirstUser extends AbstractMigration
{
    /**
     * Migrate Up
     *
     * @return void
     * @throws Exception
     */
    public function up()
    {
        /** @var UsersTable $Users */
        $Users = TableRegistry::getTableLocator()->get("Users");
        if ($Users->find()->count() === 0) {
            $user = $Users->newEntity([
                'name' => 'auto-generated user, please change my name',
                'username' => 'admin',
                'password' => 'admin',
                'mail' => 'fake@mail.com'
            ]);
            $Users->saveOrFail($user);
        }
    }

    /**
     * Migrate Down
     *
     * @return void
     */
    public function down()
    {
        /** @var UsersTable $Users */
        $Users = TableRegistry::getTableLocator()->get("Users");
        if ($Users->find()->count() === 1) {
            $user = $Users->find()->first();
            if ($user->get('name') === 'auto-generated user, please change my name') {
                $Users->deleteOrFail($user);
            }
        }
    }
}
