<?php
/**
 * Refae\Model\Entity\Category
 */

namespace Refae\Model\Entity;

use Cake\ORM\Entity;

/**
 * Entité de la table categories
 *
 * @category Entity
 *
 * @author    Ludovic Ganée <ludovic.ganee@libriciel.coop>
 * @copyright (c) 2017-2018, Libriciel SCOP
 * @license   https://opensource.org/licenses/AGPL-3.0
 */
class Category extends Entity
{
    /**
     * Traductions des type
     * @return string
     * @throws \Aura\Intl\Exception
     */
    protected function _getTypetrad(): string
    {
        if (empty($this->_properties['type'])) {
            return '';
        }
        switch ($this->_properties['type']) {
            case 'table':
                return __dx('category', 'type', 'table');
            case 'typo':
                return __dx('category', 'type', 'typo');
            case 'dossier':
                return __dx('category', 'type', 'dossier');
        }
        return $this->_properties['type'];
    }
}
