<?php
/**
 * Refae\Model\Entity\User
 */

namespace Refae\Model\Entity;

use Cake\ORM\Entity;
use Cake\Utility\Security;

/**
 * Entité de la table users
 *
 * @category Entity
 *
 * @author    Ludovic Ganée <ludovic.ganee@libriciel.coop>
 * @copyright (c) 2017-2018, Libriciel SCOP
 * @license   https://opensource.org/licenses/AGPL-3.0
 */
class User extends Entity
{
    /**
     * Encrypte le mot de passe
     *
     * @param string $password
     * @return string
     */
    protected function _setPassword(string $password): string
    {
        return Security::hash($password, 'sha256', true);
    }
}
