<?php
/**
 * @var \Refae\View\AppView $this
 */
$ans = [];
for ($i = 0; $i <= 100; $i++) {
    $ans[$i] = __n("{0} an", "{0} ans", $i, $i);
}
$select = [
    'data-placeholder' => __("-- Sélectionner une valeur --"),
    'empty' => __("-- Sélectionner une valeur --"),
];
$optionnel = ['placeholder' => __("Optionnel")];
$optionnelSpan = ['help' => __("Optionnel")];

if ($path = $this->request->getData('file_upload_profil')) {
    $decoded = urldecode($path);
    $fullPath = TMP.'upload'.DS.'user_'.$user_id.DS.$decoded;
    $uploadData = [[
        'select' => '<input type="radio" name="file_upload_profil" value="'.$path.'" checked="checked">',
        'id' => basename($decoded),
        'name' => basename($decoded),
        'size' => is_file($fullPath) ? filesize($fullPath) : 0
    ]];
}
$uploads = $this->Table
    ->create($uploadId, ['class' => 'table table-striped table-hover minifiable-target hide'])
    ->fields([
        'select' => ['label' => __("Sélectionner"), 'class' => 'radio-td'],
        'name' => ['label' => __('Nom de fichier')],
        'size' => ['label' => __('Taille'), 'callback' => 'TableHelper.readableBytes'],
        'transfert' => ['label' => __('Message'), 'class' => 'transfert', 'style' => 'min-width: 250px'],
    ])
    ->data($uploadData ?? [])
    ->params([
        'identifier' => 'id',
        'classEval' => 'data[{index}].valid !== false ? "" : "danger"',
    ])
    ->actions([
        [
            'data-callback' => "deleteFile('{0}')",
            'type' => "button",
            'class' => 'btn-link',
            'label' => $this->Fa->charte('Supprimer', 'text-danger'),
            'title' => __('Supprimer {0}', '{1}'),
            'confirm' => __("Attention, cette action ne pourra pas être annulée, le fichier sera supprimé de façon définitive. Voulez-vous continuer ?"),
            'params' => ['id', 'name']
        ],
    ])
;

$uploadContent = $this->Upload->create($uploadBoxId, $uploads->tableObject)
    ->generate([
        'attributes' => ['accept' => '.xsd, .rng, application/xml'],
        'target' => $this->Url->build('/Upload/index')
    ]);
/** @noinspection PhpUndefinedFieldInspection */
$jsUpload = $this->Upload->jsObject;
echo $this->Form->control('identifiant', ['label' => __('Identifiant'), 'required', 'disabled' => $document->get('version') > 1])
    . $this->Form->control('name', ['label' => __('Nom'), 'required'])
    . $this->Form->control('description', ['label' => __('Description'), 'type' => 'textarea', 'placeholder' => __("Optionnel")])
    .'<hr>'
    . $this->Select->betterTreeList($this->Form->control('categories._ids', ['options' => $categories, 'label' => __('Associée à'), 'multiple', 'data-placeholder' => __("-- Sélectionnez un ou plusieurs dossiers --")] +  $optionnelSpan))
    . $this->Form->control('support', ['label' => __('Support'), 'options' => $support, 'required'] + $select)
    . $this->Form->control('file_format', ['label' => __('Format de fichier')] + $optionnel)
    . $this->Form->control('localisation', ['label' => __('Localisation du document')] + $optionnel)
    .'<hr>'
    . $this->Form->control('duc', ['label' => __("Durée d'utilité courante"), 'options' => $ans] + $select +  $optionnelSpan)
    . $this->Form->control('depart_calcul_duc', ['label' => __('Date de départ de calcul de la DUC')] + $optionnel)
    .'<hr>'
    . $this->Form->control('sort_final', ['label' => __('Sort final'), 'options' => $sort_final, 'required'] + $select)
    . $this->Form->control('dua', ['label' => __("Durée d'utilité administrative"), 'options' => $ans, 'required'] + $select)
    . $this->Form->control('depart_calcul_dua', ['label' => __('Date de départ de calcul de la DUA')] + $optionnel)
    .'<hr>'
    . $this->Form->control('communicabilite', ['label' => __('Communicabilité'), 'options' => $communicabilite, 'required'] + $select)
    . $this->Form->control('depart_calcul_com', ['label' => __('Date de départ de calcul de la communicabilité')] + $optionnel)
    .'<hr>'
    . $this->Form->control('app_meta', ['label' => __("Métadonnées techniques")] + $optionnel)
    .'<hr>'
    . $this->Form->control('profil_archivage', ['label' => __("Nom du profil d'archivage")] + $optionnel)
    . $this->Html->tag('span', __("Schéma du profil d'archivage"), ['class' => 'fake-label'])
    . $uploadContent . $uploads->generate()
    . $this->Form->end()
;
?>
<script>
    var RefaeCommunicabilite = {
        comInfo: <?=$comInfo ?? '{}'?>,
        setCommunicabiliteInfo: function(target) {
            return function() {
                var parent = target.parent(),
                    value = target.val()
                ;
                parent.find('span.help-block').remove();
                if (value && typeof RefaeCommunicabilite.comInfo[value] === 'string') {
                    parent.append(
                        $('<span class="help-block"></span>').append(RefaeCommunicabilite.comInfo[value])
                    );
                }
            }
        }
    };
    var uploadTable = {table: ''};
    uploadTable.table = '#<?=$uploadId?>';
    var uploader = {config: {id: ''}};
    uploader = <?=$jsUpload?>;

    $(uploadTable.table).change(function () {
        if ($(this).find('tbody tr').length === 0) {
            $(this).addClass('hide')
                .closest('section')
                .find('button.btn-primary')
                .parent()
                .addClass('hide');
        }
    });

    setTimeout(function() {
        $('div.dropbox').off('.draganimation').on('dragover.draganimation', function() {
            $(this).addClass('dragover');
        }).on('dragleave.draganimation dragend.draganimation drop.draganimation', function() {
            $(this).removeClass('dragover');
        });
    }, 0);

    $('#'+uploader.config.id+'.dropbox').on('fileAdded', function() {
        $(uploadTable.table).removeClass('hide');
    }).on('fileSuccess', function(event, file, message) {
        var table = eval(uploader.config.table),
            data = table.getDataId(file.uniqueIdentifier)
        ;
        $('input[name="file_upload_profil"]').prop('checked', false);
        data.select = $('<input type="radio" name="file_upload_profil">')
            .attr('value', message.report.path)
            .prop('checked', true)
        ;
        table.replaceDataId(file.uniqueIdentifier, data);
    });
    if ($(uploadTable.table).find('tbody tr').length >= 1) {
        $(uploadTable.table).removeClass('hide');
    }

    function deleteFile(filename) {
        $('html').addClass('ajax-loading');
        $('tr[data-id="'+filename+'"]').addClass('warning');
        $.ajax({
            url: '<?=$this->Url->build('/Files/delete/'.($document->get('id') ?: 'add'))?>/'+filename,
            success: function() {
                $('tr[data-id="'+filename+'"]')
                    .addClass('success')
                    .fadeOut(400, function() {
                        var tbody = $(this).closest('tbody'),
                            selected = $(this).find('input[type=radio]').prop('checked')
                        ;
                        eval(uploader.config.table).removeDataId(filename);
                        $(this).remove();
                        if (tbody.find('tr').length === 0) {
                            tbody.closest('table').addClass('hide');
                        } else if (selected) {
                            tbody.find('tr').first()
                                .find('input[type=radio]')
                                .prop('checked', true)
                            ;
                        }
                    })
                ;
            },
            error: function() {
                $('tr[data-id="'+filename+'"]')
                    .addClass('danger')
                    .find('.transfert')
                    .html('')
                    .append(__("Une erreur a eu lieu lors de la suppression"))
                ;
            },
            complete: function() {
                $('tr[data-id="'+filename+'"]').removeClass('warning');
                $('html').removeClass('ajax-loading');
            }
        });
    }
</script>
