<?php
/**
 * @var \Refae\View\AppView $this
 */

$uploads = $this->Table
    ->create($uploadId, ['class' => 'table table-striped table-hover minifiable-target hide'])
    ->fields([
        'name' => ['label' => __('Nom de fichier')],
        'size' => ['label' => __('Taille'), 'callback' => 'TableHelper.readableBytes'],
        'transfert' => ['label' => __('Message'), 'style' => 'min-width: 250px'],
    ])
    ->data([])
    ->params([
        'identifier' => 'id',
        'classEval' => 'data[{index}].valid !== false ? "" : "danger"',
    ]);

$uploadContent = $this->Upload->create('upload-field', $uploads->tableObject)
    ->generate([
        'attributes'=> ['accept' => '.json, application/json'],
        'target' => $this->Url->build('/Upload/index')
    ]);

$jsUpload = $this->Upload->jsObject;

echo $uploadContent . $uploads->generate();
?>

<script>
    var uploadTable = {table: ''};
    uploadTable.table = '#<?=$uploadId?>';
    var uploader = {config: {id: ''}};
    uploader = <?=$jsUpload?>;

    $(uploadTable.table).change(function () {
        if ($(this).find('tbody tr').length === 0) {
            $(this).addClass('hide')
                .closest('section')
                .find('button.btn-primary')
                .parent()
                .addClass('hide');
        }
    });

    setTimeout(function() {
        $('div.dropbox').off('.draganimation').on('dragover.draganimation', function() {
            $(this).addClass('dragover');
        }).on('dragleave.draganimation dragend.draganimation drop.draganimation', function() {
            $(this).removeClass('dragover');
        });
    }, 0);

    $('#'+uploader.config.id+'.dropbox').off().on('fileAdded', function() {
        $(uploadTable.table).removeClass('hide');
    }).on('fileSuccess', function(event, file, message) {
        $('html').addClass('ajax-loading');
        $('#loading-screen').fadeIn(100);
        // Résout un bug sur ie
        setTimeout(function() {
            $('#loading-screen').removeClass('paused');
        }, 10);
        $.ajax({
            'url': '<?=$this->Url->build('/Documents/import-database')?>/'+message.report.uid,
            success: function(content, textStatus, jqXHR) {
                if (jqXHR.getResponseHeader('X-Asalae-Success') === 'true') {
                    $(uploadTable.table).closest('.modal').modal('hide');
                    var report = [
                        __("Règles de gestion: "),
                        __("\tajoutés: {0}", content.documents.added),
                        __("\tmodifiés: {0}", content.documents.updated),
                        __("\tignorés: {0}", content.documents.ignored),
                        __("\tn'ont pas pu être ajoutés: {0}", content.documents.skipped),
                        __("\terreurs: {0}", content.documents.errors),
                        '',
                        __("Entités gestionnaires / Dossiers:"),
                        __("\tajoutés: {0}", content.categories.added),
                    ];
                    alert(report.join("\n"));
                    AsalaeGlobal.interceptedLinkToAjax(''+location);
                } else {
                    $(uploadTable.table).find('tr[data-id="'+message.report.id+'"]')
                        .addClass('danger').removeClass('warning')
                        .find('td.transfert > div')
                        .html(content)
                    ;
                }
            },
            error: function() {
                $(uploadTable.table).find('tr[data-id="'+message.report.id+'"]').addClass('danger').removeClass('warning');
                alert(PHP.messages.genericError);
            },
            complete: function() {
                $('html').removeClass('ajax-loading');
                $('#loading-screen').fadeOut(100, function() { $(this).addClass('paused'); });
            }
        });
    });
</script>
