<?php
/**
 * @var \Refae\View\AppView $this
 */
$host = $this->request->getEnv('HTTP_HOST', '');
$actualLink = ($this->request->getEnv('HTTPS', 'off') === 'on' ? "https" : "http") . "://" . $host;
?>
<table class="table" id="report-table">
    <tbody>
        <tr>
            <th><?=__("Previous page")?></th>
            <td><?=$this->request->referer() === '/' ? $actualLink : $this->request->referer()?></td>
        </tr>
        <tr>
            <th><?=__("Request Target")?></th>
            <td><?=trim($actualLink.$this->request->getRequestTarget(), '/')?></td>
        </tr>
        <tr>
            <th><?=__("Method")?></th>
            <td><?=$this->request->getMethod()?></td>
        </tr>
        <tr>
            <th><?=__("Timestamp")?></th>
            <td><?=date('Y-m-d h:i:s', time())?></td>
        </tr>
    </tbody>
</table>
<div>
    <button type="button" id="copy-report-btn" class="btn btn-primary"><?=__("Copy the report to Clipboard")?></button>
</div>
<script>
    $('#copy-report-btn').click(function() {
        var reportText = '';
        $('h1:first, h2:first').each(function() {
            reportText += $(this).prop("tagName") + ': ' + $(this).text() + "\n";
        });
        $('#report-table').find('tr').each(function() {
            reportText += $(this).find('th').text() + ': ' + $(this).find('td').text() + "\n";
        });
        var dummy = $('<textarea id="dummy"></textarea>').val(reportText);
        $('body').append(dummy);
        dummy.get(0).select();
        document.execCommand("copy");
        dummy.remove();
    });
</script>