<?php
/**
 * @var \Refae\View\AppView $this
 */

use Cake\Core\Configure;
$css = [
    'bootstrap.min.css',
    'bootstrap-theme.min.css',
    'font-awesome.min.css',
    'font-awesome-animation.min.css',
    'jquery-ui.min.css',
    'jstree/style.min.css',
    'chosen.css',
    'asalae.css',
    'global.css'
];
if (!empty($high_contrast)) {
    $css[] = 'high_contrast.css';
}
?>
<?=$this->Html->css($css);?>

<?=$this->element('global_javascript')?>

<?php
$scripts = [
    'asalae.compatibility_enhancer.js',
    'jquery-3.2.1.min.js',
    'jquery.cookie.js',
    'jquery.actual.min.js',
    'bootstrap.min.js',
    'jquery-ui.min.js',
    'i18n/datepicker-fr.js',
    'moment-with-locales.min.js',
    'jquery.ui.touch-punch.min.js',
    'autobahn.min.js',
    'jsrender.min.js',
    'favico-0.3.10.min.js',
    'flow.js',
    'jstree/jstree.min.js',
    'jquery.orgchart.js',
    'chosen.jquery.js',
    'asalae.translation.js.php?'.filemtime(APP.'translations.php'),
    'asalae.extended_jquery.js',
    'asalae.table-generator.js',
    'asalae.formhelper.js',
    'asalae.ruletoform.js',
    'asalae.upload.js',
    'asalae.ui.js',
    'asalae.modal.js',
    'asalae.global-top.js',
    'refa.global.js'
];
if (Configure::read('Assets.javascript.use_compiled')) {
    foreach ($scripts as $key => $value) {
        $compiledName = basename($value, '.js') . '-compiled.js';
        if (is_file(COMPILED_JS . $compiledName)) {
            $scripts[$key] = COMPILED_DIR . '/' . $compiledName;
        }
    }
}
?>
<?=str_replace(' ext=""', '', $this->Html->script($scripts, ['ext' => '']));?>

<?= $this->fetch('meta') ?>

<?= $this->fetch('css') ?>

<?= $this->fetch('script') ?>

