<?php
/**
 * @var \Refae\View\AppView $this
 */

use Cake\Core\Configure;

// Page de transition Libriciel
if ($this->request->getSession()->read('loaded') === null && Configure::read('Libriciel.loading')) {
    $this->request->getSession()->write('loaded', true);
    echo $this->element('libriciel');
}

$loading = $this->Html->tag(
    'div',
    $this->Html->tag('i', '', ['class' => 'fa fa-4x fa-spinner faa-spin animated']),
    ['class' => 'text-center loading-container']
);
echo $this->ModalView->create('view-document')
    ->modal(__('Règle de gestion d’un document'), $loading)
    ->output('function',
        'RefaeHeader.loadViewModal',
        $this->Url->build('/Documents/view')
    )
    ->generate()
;

echo $this->ModalForm->create('connect-user', [
        'acceptButton' => $this->Form->button('<i class="fa fa-sign-in fa-fw" aria-hidden="true"></i> ' . __('Se connecter'), ['bootstrap-type' => 'primary', 'class' => 'accept']),
        'class' => 'login-modal'
    ])
    ->modal('')
    ->javascriptCallback("RefaeHeader.refreshPage")
    ->output('function',
        'loadConnectionModal',
        '/Users/login'
    )
    ->generate();

if ($user_id) {
    echo $this->ModalForm->create('add-document', ['size' => 'large'])
        ->modal(__("Ajouter une règle de gestion"))
        ->javascriptCallback("RefaeHeader.afterAddDocument")
        ->output('function',
            'loadAddDocumentModal',
            '/Documents/add'
        )->generate();

    echo $this->ModalView->create('user-index')
        ->modal(__('Utilisateurs'), $loading)
        ->output('function',
            'RefaeHeader.loadUsersModal',
            $this->Url->build('/Users/index')
        )
        ->generate()
    ;

    echo $this->ModalForm->create('add-tableau')
        ->modal(__("Ajouter une entité gestionnaire"))
        ->javascriptCallback("RefaeHeader.refreshPage")
        ->output('function',
            'loadAddCategorieTableauModal',
            '/Categories/add'
        )->generate();

    echo $this->ModalForm->create('add-dossier')
        ->modal(__("Ajouter un dossier"))
        ->javascriptCallback("RefaeHeader.refreshPage")
        ->output('function',
            'loadAddCategorieDossierModal',
            '/Categories/add/dossier'
        )->generate();

    echo $this->ModalView->create('import-export')
        ->modal(__('Importer des règles de gestion d’un document'), $loading)
        ->output('function',
            'RefaeHeader.loadImportExport',
            $this->Url->build('/Documents/import-export')
        )
        ->generate()
    ;

    echo $this->ModalForm->create('edit-user')
        ->modal(__("Modifier un utilisateur"))
        ->javascriptCallback("RefaeHeader.refreshPage")
        ->output('function',
            'loadEditUserModal',
            '/Users/edit'
        )->generate()
    ;
}

echo $this->Modal->create(['id' => 'lexicon-modal', 'size' => 'large'])
    . $this->Modal->header(__("Lexique"))
    . $this->Modal->body($this->element('lexique'), ['class' => 'no-padding'])
    . $this->Modal->end()
;
?>
    <!-- Menu du haut -->
    <header class="navbar-fixed-top">
        <nav class="navbar navbar-asalae">
            <div class="container-fluid">
                <!-- Brand and toggle get grouped for better mobile display -->
                <div class="navbar-header">
                    <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target=".header-menu-collapsable" aria-expanded="false">
                        <span class="sr-only"><?=__("Toggle navigation")?></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>
                    <a class="navbar-brand logo" href="<?=$this->Url->build('/')?>"><?=$this->fetch('logo');?></a>
                </div>

                <!-- Collect the nav links, forms, and other content for toggling -->
                <div class="collapse navbar-collapse header-menu-collapsable">

                    <ul class="nav navbar-nav navbar-right">
                        <li class="navbar-item">
                            <button data-toggle="modal" data-target="#lexicon-modal" class="navbar-link btn-link" type="button">
                                <?=$this->Fa->charte('Informations')?>
                                <span class="resp resp-hide-large" aria-hidden="true"> <?=__("Lexique")?> </span>
                                <span class="sr-only"><?=__("Lexique")?></span>
                            </button>
                        </li>
                        <li class="dropdown navbar-item" title="Filtrer" id="menu-li-filter" style="display: none">
                            <button data-toggle="dropdown" type="button" class="btn-link">
                                <?=$this->Fa->charte('Filtrer')?>
                                <span class="resp resp-hide-large" aria-hidden="true"> <?=__("Filtres")?> </span>
                                <span class="sr-only"><?=__("Filtres de recherche")?></span>
                            </button>
                            <ul class="dropdown-menu flex-column filtersSelectWindow">
                                <li>
                                    <button data-toggle="modal" data-target="#modal-filters" class="navbar-link btn-link" type="button">
                                        <?=$this->Fa->charte('Modifier').' '.__("Ajouter / Modifier les filtres")?>
                                    </button>
                                </li>
                                <?php if ($this->request->getParam('?.SaveFilterSelect') !== false): ?>
                                    <li class="savedFilter">
                                        <button class="navbar-link btn-link" onclick="AsalaeGlobal.confirmRemoveFilters()" type="button">
                                            <?=$this->Fa->charte('Réinitialiser').' '.__("Réinitialiser les filtres")?>
                                        </button>
                                    </li>
                                <?php endif; ?>
                                <li role="separator" class="divider"></li>
                                <?php
                                if (!empty($savedFilters)) {
                                    echo $this->Filter->selectSaved($savedFilters);
                                }
                                ?>
                            </ul>
                        </li>
                        <li>
                            <form class="navbar-form" role="search" id="search-form">
                                <div class="input-group">
                                    <input type="text" class="form-control" placeholder="Rechercher" name="searchbar" id="searchbar">
                                    <div class="input-group-btn">
                                        <button class="btn btn-default" type="submit"><i class="glyphicon glyphicon-search"></i></button>
                                    </div>
                                </div>
                            </form>
                        </li>
                        <li class="dropdown link" id="user-menu">
<?php if ($user_id): ?>
                            <a href="#" class="dropdown-toggle" data-toggle="dropdown" aria-expanded="false">
                                <?=$this->Fa->charte('Menu', ['class' => 'fa-lg'])?><span class="resp resp-hide-large"> <?=__("Ma session")?></span>
                            </a>
                            <ul class="dropdown-menu flex-column">
                                <li>
                                    <button type="button" onclick="loadEditUserModal(<?=$user_id?>)" class="btn-link navbar-link">
                                        <?=$this->Fa->i('fa-address-card-o').' '.__("Modifier mon profil")?>
                                    </button>
                                </li>
                                <li>
                                    <button type="button" onclick="RefaeHeader.deconnection()" class="btn-link navbar-link">
                                        <?=$this->Fa->charte('Se déconnecter').' '.__("Se déconnecter")?>
                                    </button>
                                </li>
                            </ul>
<?php else: ?>
                            <button type="button" onclick="loadConnectionModal()" class="btn-link navbar-link">
                                <?=$this->Fa->charte('Utilisateur')?><span class="resp resp-hide-large"> <?=__("Connexion")?> </span>
                            </button>
<?php endif; ?>
                        </li>
                    </ul>

                </div><!-- /.navbar-collapse -->
            </div><!-- /.container-fluid -->

<?php if ($user_id): ?>

            <div class="container-fluid" id="navigation-menu">
                <!-- Collect the nav links, forms, and other content for toggling -->
                <div class="collapse navbar-collapse header-menu-collapsable" id="header-menu-collapsable">
                    <ul class="nav navbar-nav">
                        <li class="dropdown dropdown-asalae navbar-item">
                            <a href="#" class="navbar-link dropdown-toggle" data-toggle="dropdown" aria-expanded="false">
                                <i class="fa fa-table"></i> <?=__("Entités gestionnaires")?> <span class="caret"></span>
                            </a>
                            <ul class="dropdown-menu flex-column">
                                <li>
                                    <button type="button" onclick="loadAddCategorieTableauModal()" class="btn-link navbar-link">
                                        <?=$this->Fa->charte('Ajouter').' '.__("Ajouter une entité gestionnaire")?>
                                    </button>
                                </li>
                                <li>
                                    <button type="button" onclick="loadAddCategorieDossierModal()" class="btn-link navbar-link">
                                        <?=$this->Fa->charte('Ajouter').' '.__("Ajouter un dossier")?>
                                    </button>
                                </li>
                            </ul>
                        </li>
                        <li class="dropdown dropdown-asalae navbar-item">
                            <a href="#" class="navbar-link dropdown-toggle" data-toggle="dropdown" aria-expanded="false">
                                <i class="fa fa-gavel"></i> <?=__("Règles de gestion")?> <span class="caret"></span>
                            </a>
                            <ul class="dropdown-menu flex-column">
                                <li>
                                    <button type="button" onclick="loadAddDocumentModal()" class="btn-link navbar-link">
                                        <?=$this->Fa->charte('Ajouter').' '.__("Ajouter une règle de gestion")?>
                                    </button>
                                </li>
                                <li>
                                    <a href="<?=$this->Url->build('/')?>" class="navbar-link">
                                        <?=$this->Fa->i('fa-globe').' '.__("Règles de gestion publiées")?>
                                    </a>
                                </li>
                                <li>
                                    <a href="<?=$this->Url->build('/Documents/index/brouillon')?>" class="navbar-link">
                                        <?=$this->Fa->i('fa-clock-o').' '.__("En attente de publication")?>
                                    </a>
                                </li>
                                <li>
                                    <a href="<?=$this->Url->build('/Documents/index/obsolete?last-version[0]=1')?>" class="navbar-link">
                                        <?=$this->Fa->i('fa-calendar-times-o').' '.__("Obsolètes")?>
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="navbar-item">
                            <button type="button" onclick="RefaeHeader.loadUsersModal()" class="btn-link navbar-link">
                                <?=$this->Fa->charte('Utilisateurs').' '.__("Utilisateurs")?>
                            </button>
                        </li>
                        <li class="dropdown dropdown-asalae navbar-item">
                            <a href="#" class="navbar-link dropdown-toggle" data-toggle="dropdown" aria-expanded="false">
                                <i class="fa fa-usb"></i> <?=__("Import / Export")?> <span class="caret"></span>
                            </a>
                            <ul class="dropdown-menu flex-column">
                                <li>
                                    <button type="button" onclick="RefaeHeader.export('database')" class="btn-link navbar-link">
                                        <?=$this->Fa->i('fa-download').' '.__("Télécharger une sauvegarde des règles de gestion")?>
                                    </button>
                                </li>
                                <li>
                                    <button type="button" onclick="RefaeHeader.loadImportExport()" class="btn-link navbar-link">
                                        <?=$this->Fa->i('fa-upload').' '.__("Importer une sauvegarde des règles de gestion")?>
                                    </button>
                                </li>
                                <li>
                                    <button type="button" onclick="RefaeHeader.export('csv')" class="btn-link navbar-link">
                                        <?=$this->Fa->i('fa-file-excel-o').' '.__("Export {0}", 'CSV')?>
                                    </button>
                                </li>
                                <li>
                                    <button type="button" onclick="RefaeHeader.export('json')" class="btn-link navbar-link">
                                        <?=$this->Fa->i('fa-file-text-o').' '.__("Export {0}", 'JSON')?>
                                    </button>
                                </li>
                                <li>
                                    <button type="button" onclick="RefaeHeader.export('xml')" class="btn-link navbar-link">
                                        <?=$this->Fa->i('fa-file-code-o').' '.__("Export {0}", 'XML')?>
                                    </button>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </div><!-- /.navbar-collapse -->
            </div><!-- /.container-fluid -->

<?php endif; ?>
        </nav>
    </header>
    <script>
        RefaeHeader.loading = '<?=$loading?>';
        RefaeHeader.searchData = <?=$searchData ?? '[]'?>;
        RefaeHeader.baseHref = "<?=$this->Url->build('/')?>";
        RefaeHeader.urls = {
            docbrouillon: "<?=$this->Url->build('/Documents/index/brouillon')?>",
            userlogout: "<?=$this->Url->build('/users/logout')?>",
        };
        RefaeHeader.export = function(type) {
            window.location = ''+location+((''+location).indexOf('?') >= 0 ? '&' : '?')+'export='+type;
        }
        AsalaeModal.append($('#lexicon-modal'));
    </script>
