<?php
/**
 * @var \AsalaeCore\View\AppView $this
 */

use Cake\Utility\Inflector;

$jsVarTable = $jsVarTable ?? Inflector::camelize(
        'generated_'.preg_replace('/[^\w]/', '_', $idTable)
    );
?>
<?= $this->Modal->create(
        __('Configuration du tableau de résultats'),
        ['id' => 'modal-'.$idTable, 'class' => 'ui-draggable-handle']
);?>

<div class="cancelable">
    <h4 class="fake-label"><?=__("Méthode d'affichage")?></h4>
    <div class="text-center table-style">
        <i role="button" tabindex="0" class="fa fa-4x fa-th btn switch-table-view" data-view="default" title="<?=__("Plusieurs colonnes")?>"><span class="sr-only"><?=__("Plusieurs colonnes")?></span></i>
        <i role="button" tabindex="0" class="fa fa-4x fa-th-list btn switch-table-view" data-view="div" title="<?=__("Une seule colonne")?>"><span class="sr-only"><?=__("Une seule colonne")?></span></i>
    </div>

    <div class="form-group showed">
        <h4 class="fake-label"><?=__("Affichés")?></h4>
        <div class="drop-zone"></div>
    </div>

    <div class="form-group hidded">
        <h4 class="fake-label"><?=__("Disponibles")?></h4>
        <div class="drop-zone"></div>
    </div>
<?php if ($paginate ?? true) : ?>
    <div class="form-group hidded">
        <label><?=__("Nombre maximal de résultats par pages")?>
            <select class="nb-max-results">
                <option>10</option>
                <option>20</option>
                <option>50</option>
                <option>100</option>
            </select>
        </label>
    </div>
<?php endif; ?>
    <div class="form-group delete text-right">
        <button class="btn btn-default" id="delete-cookies-<?=$idTable?>"><?=$this->Fa->charte('Réinitialiser').' '.__("Réinitialiser")?></button>
    </div>
</div>
<script>
    $(function() {
        var table = {};
        table = <?=$jsVarTable?>;

        // Suppression des cookies
        $('#delete-cookies-<?=$idTable?>').click(function() {
            if (confirm("<?=__("Cette action va supprimer vos préférences de façon permanente. Voulez-vous continuer ?")?>")) {
                var table = {};
                table = <?=$jsVarTable?>;
                table.deleteCookies();
                if (confirm("<?=__("Vous devez recharger la page pour prendre en compte toutes les modifications. Voulez-vous le faire maintenant ?")?>")) {
                    location.reload();
                }
            }
        });

        // active le type de tableau par cookies
        if ($.cookie(table.cookies.view) === 'div') {
            $('#modal-<?=$idTable?> i.fa-th-list').addClass('active');
        } else {
            $('#modal-<?=$idTable?> i.fa-th').addClass('active');
        }
    });
</script>
<?= $this->Modal->end([
    $this->Form->button($this->Fa->charte('Annuler', 1).' '.__('Annuler'), ['data-dismiss' => 'modal', 'class' => 'cancel']),
    $this->Form->button($this->Fa->i('fa-level-down').' '.__('Appliquer'), ['class' => 'apply']),
    $this->Form->button($this->Fa->charte('Enregistrer').' '.__('Enregistrer'), ['bootstrap-type' => 'primary', 'data-dismiss' => 'modal', 'class' => 'accept'])
])
    . $this->ModalForm->modalScript('modal-'.$idTable)
; ?>