<?php
/**
 * @var \Refae\View\AppView $this
 * @var Cake\Core\Exception\Exception $error
 */
use Cake\Core\Configure;


$this->assign('title-appname', 'Refae: '.$this->fetch('title'));
$this->assign('main-head', $this->element('head'));



$this->start('main-modals');
if (isset($modals)) {
    foreach ((array)$modals as $modal) {
        echo $modal . PHP_EOL . PHP_EOL;
    }
}
$this->end();



$this->start('footer');
if (!empty($user_id)) {
    echo $this->element('session_timeout');
}
?>
<!-- Footer -->
<footer>
    <div class="container-fluid">
        ref@e 1.0.0-rc3 - © 2018 Libriciel SCOP
        <span class="hidden-xs navbar-right navbar-icons-buffer-top">
            <a href="https://www.libriciel.fr" class="pull-right" target="_blank" title="libriciel">
                <?=$this->Html->image("Libriciel_white_h24px.png", ['alt' => "Libriciel"])?>
            </a>
        </span>
    </div>
</footer>
<?php
$this->end();


/**
 * Structure HTML
 */
?>
<!DOCTYPE html>
<html lang="<?=str_replace('_', '-', \Cake\I18n\I18n::getLocale())?>">
<head><?php if ($this->response->getStatusCode() >= 400 && Configure::read('debug') && !empty($error) && !empty($message)): ?>
<!-- Facilite la lecture d'une erreur en ajax

<?=sprintf('%s, line %s', $error->getFile(), $error->getLine())?>

<?=preg_replace('/([,\.])\s+/', "$1\n", h($message))?>

-->
    <?php endif; ?>
    <?=$this->Html->charset()?>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title><?=$this->fetch('title-appname')?></title>
    <?=$this->Html->meta('icon')?>

    <?= $this->Html->meta('favicon.png', '/favicon.png', ['type' => 'icon'])?>

    <?=$this->fetch('main-head')?>
</head>
<body<?=$user_id ? ' class="connected"' : ''?>>
<?=$this->fetch('main-modals')?>
<div id="body-content">

    <div id="notifications-container"></div>

    <?=$this->fetch('main-header')?>

    <?=$this->fetch('main-content')?>
</div>
<?=$this->element('loading')?>

<!-- Footer -->
<?=$this->fetch('footer')?>
<?=(Configure::read('Assets.javascript.use_compiled')
    ? $this->Html->script(COMPILED_DIR . '/asalae.global-compiled.js')
    : $this->Html->script('asalae.global.js')
)?>

</body>
</html>