<?php
/**
 * @var \Refae\View\AppView $this
 * @var \Refae\Model\Entity\User $user
 */
use Cake\Core\Configure;

echo $this->Form->control('name', ['label' => __("Nom d'utilisateur"), 'required' => true])
    . $this->Form->control('mail', ['label' => __("E-mail"), 'required' => true])
    . $this->Form->control('username', ['label' => __("Identifiant"), 'required' => true])
    . '<input type="password" class="hide" value="false"><!-- neutralise le préremplissage firefox -->'
    . $this->Form->control('password', [
        'label' => $this->request->getParam('action') === 'edit' ? __("Password (laisser vide pour ne rien changer)") : __('Password'),
        'type' => 'password',
        'append' => '<span class="color-dot empty">',
        'escape' => false,
        'required' => false,
        'value' => '',
        'templates' => [
            'label' => '<label{{attrs}}>{{text}}</label><div id="'.$idJauge.'"></div>'
        ]
    ])
    . $this->Form->control('confirm-password', [
        'label' => __("Confirmer le password"),
        'type' => 'password',
        'append' => '<span class="color-dot empty">'
    ]);
?>
<script>
    var minScore = <?=Configure::read('Password.complexity') ?? PASSWORD_ULTRA_WEAK?>;
    $('#<?=$idJauge?>').append(
        $('<div></div>')
            .addClass('progress')
            .height('5px')
            .css({'margin-bottom': '5px'})
            .append(
                $('<div></div>')
                    .addClass('progress-bar')
                    .attr('role', 'progressbar')
                    .attr('aria-valuenow', 0)
                    .attr('aria-valuemin', 0)
                    .attr('aria-valuemax', <?=PASSWORD_STRONG?>)));

    function inputPasswordKeyup() {
        var score = AsalaeGlobal.passwordScore($(this).val()),
            progressBar = $('#<?=$idJauge?>').find('.progress .progress-bar');
        progressBar.removeClass('progress-bar-striped');

        if (!$(this).val()) {
            $(this).parent().find('span.color-dot').removeClass('green')
                .removeClass('red')
                .addClass('empty');
        } else {
            if (score > minScore) {
                $(this).parent().find('span.color-dot').removeClass('empty')
                    .removeClass('red')
                    .addClass('green');
            } else {
                $(this).parent().find('span.color-dot').removeClass('empty')
                    .removeClass('green')
                    .addClass('red');
            }
        }
        if (score < <?=PASSWORD_ULTRA_WEAK?>) {
            progressBar
                .removeClass('progress-bar-warning')
                .removeClass('progress-bar-info')
                .removeClass('progress-bar-success')
                .addClass('progress-bar-danger');
        } else if (score < <?=PASSWORD_WEAK?>) {
            progressBar
                .removeClass('progress-bar-danger')
                .removeClass('progress-bar-info')
                .removeClass('progress-bar-success')
                .addClass('progress-bar-warning');
        } else if (score < <?=PASSWORD_MEDIUM?>) {
            progressBar
                .removeClass('progress-bar-danger')
                .removeClass('progress-bar-warning')
                .removeClass('progress-bar-success')
                .addClass('progress-bar-info');
        } else {
            progressBar
                .removeClass('progress-bar-danger')
                .removeClass('progress-bar-warning')
                .removeClass('progress-bar-info')
                .addClass('progress-bar-success');
        }
        if (score >= <?=PASSWORD_STRONG?>) {
            progressBar
                .addClass('progress-bar-striped');
            score = <?=PASSWORD_STRONG?>;
        }
        progressBar
            .attr('aria-valuenow', score)
            .width(score / <?=PASSWORD_STRONG?> * 100 + '%');
    }
</script>