<?php
/**
 * @var \Refae\View\AppView $this
 */
$this->Form->button('add', ['label' => 'Ajouter', 'type' => 'button']);
echo $this->ModalForm->create('add-user')
    ->modal(__("Ajouter un utilisateur"))
    ->javascriptCallback("RefaeHeader.refreshPage")
    ->output('button',
        '<i class="fa fa-plus-circle"></i> '.__("Ajouter"),
        '/Users/add'
    )->generate(['class' => 'btn btn-success'])
;

echo '<hr>';

$table = $this->Table
    ->create('users', ['class' => 'table table-striped table-hover minifiable-target smart-td-size'])
    ->fields([
        'Users.name' => ['label' => __('Nom')],
        'Users.username' => ['label' => __('Identifiant')],
        'Users.mail' => ['label' => __('E-mail')],
    ])
    ->data($users)
    ->params([
        'identifier' => 'Users.id',
        'checkbox' => false,
    ])
    ->actions([
        [
            'onclick' => "loadEditUserModal({0})",
            'type' => "button",
            'class' => 'btn-link',
            'label' => $this->Fa->charte('Modifier'),
            'title' => __('Modifier {0}', '{1}'),
            'params' => ['Users.id', 'Users.name']
        ],
        [
            'onclick' => "actionDeleteUser({0})",
            'type' => "button",
            'class' => 'btn-link',
            'label' => $this->Fa->charte('Supprimer', ['class' => 'text-danger']),
            'title' => __('Supprimer {0}', '{1}'),
            'params' => ['Users.id', 'Users.name']
        ],
    ])
;
$jsTable = $table->tableObject;

echo $this->Html->tag('div', $table->generate(), ['class' => 'row']);
?>
<script>
    function actionDeleteUser(id) {
        var table;
        table = <?=$jsTable?>;
        if (confirm("Cette action supprimera de façon définitive l'utilisateur et sera consigné dans le registre. Voulez-vous continuer ?")) {
            $('html').addClass('ajax-loading');
            $('.main-content').fadeOut();
            $('#loading-screen').fadeIn(100);
            // Résout un bug sur ie
            setTimeout(function() {
                $('#loading-screen').removeClass('paused');
            }, 10);
            $.ajax({
                url: "<?=$this->Url->build('/users/delete')?>/"+id,
                method: 'DELETE',
                complete: function() {
                    window.location.reload();
                }
            });
        }
    }
</script>
