<?php
/**
 * Refae\View\Helper\SelectHelper
 */

namespace Refae\View\Helper;

use Cake\View\Helper;

/**
 * Helper pour la mise en forme des selects
 *
 * @category Helper
 *
 * @author    Ludovic Ganée <ludovic.ganee@libriciel.coop>
 * @copyright (c) 2018, Libriciel SCOP
 * @license   https://opensource.org/licenses/AGPL-3.0
 */
class SelectHelper extends Helper
{
    /**
     * Améliore l'apparence d'un select avec des valeurs indentés par underscore(_)
     * exemple:
     * <option value="9" selected="selected">__Animations Commerciales Carbonnieres</option>
     * devient
     * <option value="9" selected="selected" class="level-2">Animations Commerciales Carbonnieres</option>
     * @param string $select
     * @return string
     */
    public function betterTreeList(string $select): string
    {
        $offset = 0;
        while ($pos = strpos($select, '<option', $offset)) {
            if (preg_match('/(<option[^>]+)>(_*)([^<]+)<\/option>/', $select, $matchs, PREG_OFFSET_CAPTURE, $offset)) {
                $level = strlen($matchs[2][0]);
                $before = substr($select, 0, $matchs[0][1]);
                $after = substr($select, strlen($matchs[0][0]) + $matchs[0][1]);
                if (!preg_match('/value=[\'"][^\'"]+[\'"]/i', $matchs[1][0])) {
                    $replace = $matchs[1][0].' class="empty">'.$matchs[3][0].'</option>';
                } else {
                    $replace = $matchs[1][0].' class="level-'.$level.'">'.$matchs[3][0].'</option>';
                }
                $select = $before . $replace . $after;
                $offset = $matchs[0][1] + strlen($replace);
            } else {
                $offset = $pos +10;
            }
        }
        return $select;
    }
}
