<?php
/**
 * AsalaeCore\Controller\Component\JstableComponent
 */

namespace AsalaeCore\Controller\Component;

use Cake\Controller\Component;
use Cake\ORM\TableRegistry;

/**
 * Component d'un controller utilisant des tables js (asalae.table-generator.js)
 *
 * @category Controller
 *
 * @author    Ludovic Ganée <ludovic.ganee@libriciel.coop>
 * @copyright (c) 2017, Libriciel
 * @license   http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
 */
class JstableComponent extends Component
{

    /**
     * Permet de modifier le nombre d'enregistrements affichés
     * dans la configuration du tableau
     *
     * @param string $idTable
     */
    public function configurablePagination(string $idTable)
    {
        $cookie = 'table-generator-config-table-'.$idTable.'-max-per-page';
        $c = $this->getController()->getRequest()->getCookie($cookie);
        if ($c && is_numeric($c)) {
            $this->getController()->paginate['limit'] = (int)$c;
        }
    }

    /**
     * Sauvegarde en base de données les cookies de l'utilisateur
     */
    public function saveCookies()
    {
        $Users = TableRegistry::getTableLocator()->get('Users');
        $cookies = $this->getController()->getRequest()->getCookieParams();
        unset($cookies['CAKEPHP']);
        $id = $this->getController()->getRequest()->getSession()->read('Auth.User.id');
        if ($id) {
            $entity = $Users->get($id);
            $json = json_encode($cookies);
            if ($entity->get('cookies') !== $json) {
                $Users->patchEntity($entity, ['cookies' => json_encode($cookies)]);
                $Users->save($entity);
            }
        }
    }
}
