<?php
/**
 * AsalaeCore\Controller\Component\ModalComponent
 */

namespace AsalaeCore\Controller\Component;

use Cake\Controller\Component;

/**
 * Component d'un controller utilisant des modales
 *
 * @category Controller
 *
 * @author    Ludovic Ganée <ludovic.ganee@libriciel.coop>
 * @copyright (c) 2017-2018, Libriciel
 * @license   http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
 */
class ModalComponent extends Component
{

    /**
     * Envoi un code HTTP X-Asalae-Success pour les modal de type formulaire
     */
    public function success()
    {
        $response = $this->getController()
            ->getResponse()
            ->withHeader('X-Asalae-Success', 'true')
        ;
        $this->getController()->setResponse($response);
    }

    /**
     * Envoi un code HTTP X-Asalae-Success pour les modal de type formulaire
     */
    public function fail()
    {
        $response = $this->getController()
            ->getResponse()
            ->withHeader('X-Asalae-Success', 'false')
        ;
        $this->getController()->setResponse($response);
    }
}
