<?php
/**
 * AsalaeCore\Controller\Component\TasksComponent
 */

namespace AsalaeCore\Controller\Component;

use Cake\Controller\Component;
use Beanstalk\Utility\CakeEmitter;
use Exception;

/**
 * Administration technique de asalae2
 *
 * @category Component
 *
 * @author    Ludovic Ganée <ludovic.ganee@libriciel.coop>
 * @copyright (c) 2017, Libriciel
 * @license   http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
 */
class TasksComponent extends Component
{
    /**
     * Suppression du tube
     *
     * @param string $tubeName
     * @return bool success
     */
    public function deleteTube(string $tubeName): bool
    {
        try {
            $pheanstalk = CakeEmitter::getPheanstalk();

            while ($pheanstalk->statsTube($tubeName)['current-jobs-buried']) {
                $job = $pheanstalk->peekBuried($tubeName);
                $pheanstalk->delete($job);
            }

            while ($pheanstalk->statsTube($tubeName)['current-jobs-delayed']) {
                $job = $pheanstalk->peekDelayed($tubeName);
                $pheanstalk->delete($job);
            }

            while ($pheanstalk->statsTube($tubeName)['current-jobs-ready']) {
                $job = $pheanstalk->peekReady($tubeName);
                $pheanstalk->delete($job);
            }

            return true;
        } catch (Exception $ex) {
        }

        return false;
    }
}
