<?php
/**
 * AsalaeCore\Model\Behavior\AliasBehavior
 */

namespace AsalaeCore\Model\Behavior;

use Cake\ORM\Behavior;
use Cake\ORM\Table;

/**
 * Permet d'obtenir une table avec un alias différent de façon dynamique
 *
 * @category Behavior
 *
 * @author    Ludovic Ganée <ludovic.ganee@libriciel.coop>
 * @copyright (c) 2018, Libriciel
 * @license   http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
 */
class AliasBehavior extends Behavior
{
    /**
     * Renvoi la table avec un alias différent
     * @param string $alias
     * @return Table
     */
    public function withAlias(string $alias): Table
    {
        $newTable = clone $this->_table;
        return $newTable->setAlias($alias);
    }
}
