<?php
/**
 * AsalaeCore\Model\Table\SavedFiltersTable
 */

namespace AsalaeCore\Model\Table;

use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Table saved_filters
 *
 * @category Table
 *
 * @author    Ludovic Ganée <ludovic.ganee@libriciel.coop>
 * @copyright (c) 2017, Libriciel
 * @license   http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
 * @mixin \Cake\ORM\Behavior\TimestampBehavior
 */
class SavedFiltersTable extends Table
{

    /**
     * Configuration initale de la table
     *
     * @param array $config
     */
    public function initialize(array $config)
    {
        $this->addBehavior('Timestamp');

        $this->belongsTo('Users');
        $this->hasMany('Filters');

        parent::initialize($config);
    }

    /**
     * Default validation rules.
     *
     * @param Validator $validator Validator instance.
     * @return Validator
     * @throws \Aura\Intl\Exception
     */
    public function validationDefault(Validator $validator): Validator
    {
        $validator->add('name', [
            'unique' => [
                'rule' => ['validateUnique', ['scope' => 'controller']],
                'provider' => 'table',
                'message' => __("Un nom de sauvegarde identique existe déjà")
            ]
        ]);
        return $validator;
    }
}
