<?php
/**
 * AsalaeCore\View\Helper\ModalFormHelper
 */

namespace AsalaeCore\View\Helper;

use AsalaeCore\View\Helper\Object\ModalForm;
use AsalaeCore\View\Helper\Object\ObjectInterface;
use Cake\View\Helper;

/**
 * Initialise une modal de formulaire et crée le bouton/lien pour l'afficher
 *
 * @category Helper
 *
 * @author    Ludovic Ganée <ludovic.ganee@libriciel.coop>
 * @copyright (c) 2017, Libriciel
 * @license   http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
 * @property \AsalaeCore\View\Helper\FormHelper $Form
 * @property \Cake\View\Helper\HtmlHelper $Html
 * @property \Bootstrap\View\Helper\ModalHelper $Modal
 * @property \Cake\View\Helper\UrlHelper $Url
 */
class ModalFormHelper extends Helper implements ObjectHelperInterface
{
    /**
     * Helpers utilisés
     *
     * @var array
     */
    public $helpers = [
        'Form',
        'Html',
        'Modal' => ['className' => 'Bootstrap.Modal'],
        'Url'
    ];

    /**
     * Initialise une nouvelle modale
     * @param string $id
     * @param array $params
     * @return ObjectInterface|ModalForm
     */
    public function create(string $id, array $params = []): ObjectInterface
    {
        return new ModalForm($this, $id, $params);
    }

    /**
     * Permet d'obtenir le javascript additionnel qui va avec la modale
     * @param string $id
     * @return string
     */
    public function modalScript(string $id): string
    {
        return "<script> AsalaeModal.append($('#$id')); </script>";
    }
}
