<?php
/**
 * AsalaeCore\View\Helper\ObjectHelperInterface
 */

namespace AsalaeCore\View\Helper;

use AsalaeCore\View\Helper\Object\ObjectInterface;

/**
 * Interface des helpers créateur d'objets
 *
 * @category Helper
 *
 * @author    Ludovic Ganée <ludovic.ganee@libriciel.coop>
 * @copyright (c) 2017, Libriciel
 * @license   http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
 */
interface ObjectHelperInterface
{
    /**
     * Permet de créer et de récupérer l'objet
     *
     * @param string $id
     * @param array $params
     * @return ObjectInterface
     */
    public function create(string $id, array $params = []): ObjectInterface;
}
