<?php
/**
 * AsalaeCore\View\Helper\TableHelper
 */

namespace AsalaeCore\View\Helper;

use AsalaeCore\View\Helper\Object\ObjectInterface;
use AsalaeCore\View\Helper\Object\Table;
use Cake\Core\Configure;
use Cake\View\Helper;

/**
 * Permet d'utiliser le générateur de tableau javascript
 *
 * @category Helper
 *
 * @author    Ludovic Ganée <ludovic.ganee@libriciel.coop>
 * @copyright (c) 2017, Libriciel
 * @license   http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
 * @property \Cake\View\Helper\HtmlHelper $Html
 * @property PaginatorHelper $Paginator
 */
class TableHelper extends Helper implements ObjectHelperInterface
{
    /**
     * Classes css par défaut
     *
     * @var array
     */
    public $defaultCssClass = ['table', 'table-striped', 'table-hover'];

    /**
     * Helpers utilisés
     *
     * @var array
     */
    public $helpers = ['Html', 'Paginator'];

    /**
     * Aparance du json
     *
     * @var integer
     */
    public $jsonStyle;

    /**
     * Initialisation du helper
     *
     * @param array $config
     */
    public function initialize(array $config)
    {
        parent::initialize($config);

        $this->jsonStyle = Configure::read('debug')
            ? JSON_PRETTY_PRINT
            : 0;
    }

    /**
     * Permet de créer et de récupérer l'objet
     *
     * @param string $id
     * @param array $params
     * @return ObjectInterface|Table
     */
    public function create(string $id, array $params = []): ObjectInterface
    {
        return new Table($this, $id, $params);
    }
}
