<?php

namespace Beanstalk\Test\lib;

use Beanstalk\lib\Emitter;
use Beanstalk\lib\Worker;
use Cake\Core\Configure;
use PHPUnit\Framework\TestCase;

class ClientTest extends TestCase
{
    const DEFAULT_HOST = 'localhost';
    const DEFAULT_PORT = 11300;

    public function testEmitAndGet()
    {
        $Worker = new Worker(
            'tube_phpunit',
            Configure::read('Beanstalk.host', self::DEFAULT_HOST),
            Configure::read('Beanstalk.port', self::DEFAULT_PORT)
        );
        $Emitter = new Emitter(
            'tube_phpunit',
            Configure::read('Beanstalk.host', self::DEFAULT_HOST),
            Configure::read('Beanstalk.port', self::DEFAULT_PORT)
        );
        $this->assertEquals('integer', gettype($Emitter->emit('test'))); // jobid
        $this->assertTrue($Worker->getNext());
        $this->assertEquals('test', $Worker->getData());
        $Worker->done(); // supprimer le job
    }
}
