<?php
/**
 * Libriciel\Filesystem\Shell\FileSystemShell
 */

namespace Libriciel\Filesystem\Shell;

use Cake\Console\Shell;
use Libriciel\Filesystem\Utility\FileSystem;

/**
 * Assure le rollback en cas d'interuption brutale d'un process du FileSystemUtility
 *
 * A utiliser avec cron
 *
 * @category    Shell
 *
 * @author      Ludovic Ganée <ludovic.ganee@libriciel.coop>
 * @copyright   (c) 2017, Libriciel
 * @license     http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
 */
class FilesystemShell extends Shell
{

    /**
     * Vérifi l'existance des processes utilisant le rollback fichier
     * Appel FileSystemShell::rollback($dirname) si le process n'existe plus
     */
    public function main()
    {
        foreach (glob(TMP . 'FileSystem' . DS . '*') as $dirname) {
            $pid = (int)basename($dirname);
            if (!file_exists('/proc/'.$pid)) {
                $this->out(__d('cakephp-filesystem', "Rollback process {0}", $pid));
                FileSystem::rollbackProcess($pid);
            } else {
                $this->out(__d('cakephp-filesystem', '{0} is still running...', $pid));
            }
        }
    }
}
