'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/*global Form, Infinity, TableGenerator*/

var XsdForm = function () {
    /**
     * Initialise la classe
     *
     * @param {object} xsdJson
     * @param {string|jquery|Element} jstreeDiv
     * @param {string|jquery|Element} formDiv
     * @param {string|jquery|Element} docDiv
     * @param {array} blackList
     */
    function XsdForm(xsdJson, jstreeDiv, formDiv, docDiv) {
        var blackList = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : [];

        _classCallCheck(this, XsdForm);

        this.xsd = xsdJson;
        this.icons = {
            attribute: '<i aria-hidden="true" class="fa fa-bookmark"></i>',
            element: '<i aria-hidden="true" class="fa fa-file-o"></i>',
            close: '<span class="pull-right"><i aria-hidden="true" class="fa fa-times slide-icon"></i></span>' // event click sur "fa-times"
        };
        this.jstree = $(jstreeDiv);
        this.form = $(formDiv);
        this.doc = $(docDiv);
        this.blackList = blackList;
        this.data = null;
        this.auto_open_count = 1;
        this.TableGenerator = null;
        this.tableGeneratorActions = {
            "action_0": {
                "href": "javascript:XsdForm.removeCallback('{0}', {1})",
                role: "button",
                "label": "<i aria-hidden=\"true\" class=\"fa fa-times text-danger\"><\/i>",
                "title": XsdForm.texts.removeTitle,
                "params": ['target', 'instance']
            },
            "action_1": {
                "href": "javascript:XsdForm.openCallback('{0}', {1})",
                role: "button",
                "label": "<i aria-hidden=\"true\" class=\"fa fa-folder-open-o\"><\/i>",
                "title": XsdForm.texts.openTitle,
                "params": ['target', 'instance']
            },
            "action_2": {
                "href": "javascript:XsdForm.viewdocCallback('{0}')",
                role: "button",
                "label": "<i aria-hidden=\"true\" class=\"fa fa-info-circle\"><\/i>",
                "title": XsdForm.texts.viewTitle,
                "params": ['target']
            }
        };
        this.tableGeneratorParams = {
            "thead": [[{
                "_id": "key",
                "label": XsdForm.texts.element,
                "title": XsdForm.texts.element,
                "link": false,
                "type": "th",
                "data-view": "default",
                "display": true,
                "colspan": 1,
                "target": "key",
                "thead": null,
                "callback": null,
                "style": null
            }, {
                "_id": "value",
                "label": XsdForm.texts.value,
                "title": XsdForm.texts.value,
                "link": false,
                "type": "th",
                "data-view": "default",
                "display": true,
                "colspan": 1,
                "target": "value",
                "thead": null,
                "callback": XsdForm.getValue,
                "style": null
            }, {
                "_id": "elements",
                "label": XsdForm.texts.elements,
                "title": XsdForm.texts.elements,
                "link": false,
                "type": "th",
                "data-view": "default",
                "display": true,
                "colspan": 1,
                "target": "value",
                "thead": null,
                "callback": XsdForm.getElements,
                "style": null
            }, {
                "_id": "args",
                "label": XsdForm.texts.args,
                "title": XsdForm.texts.args,
                "link": false,
                "type": "th",
                "data-view": "default",
                "display": true,
                "colspan": 1,
                "target": "value",
                "thead": null,
                "callback": XsdForm.getArgs,
                "style": null
            }, {
                "_id": "actions",
                "label": "Actions",
                "title": "Actions",
                "link": false,
                "type": "th",
                "class": "action",
                "data-view": "column",
                "display": true,
                "colspan": 1,
                "target": "actions",
                "thead": {
                    "action_0": {
                        "_id": "action_0",
                        "label": false,
                        "title": XsdForm.texts.removeTitle,
                        "link": false,
                        "type": "th",
                        "data-view": "default",
                        "display": true,
                        "colspan": 1,
                        "target": "action_0",
                        "thead": null,
                        "callback": null
                    },
                    "action_1": {
                        "_id": "action_1",
                        "label": false,
                        "title": XsdForm.texts.openTitle,
                        "link": false,
                        "type": "th",
                        "data-view": "default",
                        "display": true,
                        "colspan": 1,
                        "target": "action_1",
                        "thead": null,
                        "callback": null
                    },
                    "action_2": {
                        "_id": "action_2",
                        "label": false,
                        "title": XsdForm.texts.viewTitle,
                        "link": false,
                        "type": "th",
                        "data-view": "default",
                        "display": true,
                        "colspan": 1,
                        "target": "action_2",
                        "thead": null,
                        "callback": null
                    }
                }
            }]],
            "tbody": {
                "identifier": "id",
                "checkbox": false
            }
        };
        if (typeof XsdForm.instance === 'undefined') {
            XsdForm.instance = [];
        }
        var i = 0;
        do {
            this.instanceIndex = i;
            i++;
        } while (typeof XsdForm.instance[this.instanceIndex] !== 'undefined');
        XsdForm.instance[this.instanceIndex] = this;
        XsdForm.lastInstance = this;
    }

    /**
     * Transforme les {"Foo": {"bar": "baz"}} en {"Foo": {"bar": {"@": "baz"}}}
     * Afin que toutes les valeurs se situe dans un objet sous '@', même lorsque
     * il n'y a pas d'autres attributs
     * @param {object} data
     * @returns {object} data
     * @private
     */


    _createClass(XsdForm, [{
        key: 'update',


        /**
         * Construit/Reconstruit l'arbre du xml
         *
         * @param {object} data
         * @returns {XsdForm}
         */
        value: function update() {
            var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

            var that = this;
            $(this).trigger('data_changed');
            if (!data) {
                data = this.data;
            } else {
                this.data = XsdForm._format(data);
            }
            var tree = $('<div class="jstree_tree"></div>').jstree({
                core: { data: this._buildTree(data) }
            }).on('select_node.jstree', function (event, data) {
                if (data && data.selected && data.selected.length) {
                    if (data.node.icon === 'jstree-add-folder') {
                        that._createNode(data.node.id);
                    }
                    that._buildForm(data.node.id);
                }
            }).on('loaded.jstree', function () {
                that.jstree.trigger('loaded.jstree');
                $(that.jstree).find('.jstree-anchor').on('click', function (event, data) {
                    var _this = this;

                    var modal = $(that.jstree).closest('.modal').get(0);
                    modal.style.opacity = 0.8;
                    // Donne le temps à l'animation de se lancer
                    event.stopPropagation();
                    setTimeout(function () {
                        return $(_this).trigger('click.jstree');
                    }, 0);
                });
            }).on('activate_node.jstree', function () {
                $(that.jstree).closest('.modal').fadeTo(200, 1).css('cursor', '');
            });
            this.jstree.empty().append(tree);

            return this;
        }

        /**
         * @see http://jsfiddle.net/53cvtbv9/1/
         * @param {object} data
         * @param {string} id
         * @return {object}
         */

    }, {
        key: '_buildTree',
        value: function _buildTree(data) {
            var id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

            var obj = false;
            if ((typeof data === 'undefined' ? 'undefined' : _typeof(data)) === 'object') {
                var rules = id.length > 0 ? this._getRulesById(id) : {};
                obj = [];
                for (var key in data) {
                    if (this.blackList.indexOf(key) !== -1 || key === '@') {
                        continue;
                    }
                    var count = 0;
                    if (Array.isArray(data[key])) {
                        for (var _i = 0; _i < data[key].length; _i++) {
                            obj.push({
                                "id": (id ? id + "_" + key + '_' + _i : key + '_' + _i).replace(/@/g, ':at:'),
                                "text": key,
                                "icon": key.indexOf('@') === 0 ? "jstree-attr" : "jstree-folder",
                                "state": {
                                    "opened": (id.match(/_/g) || []).length < this.auto_open_count, // Ouvre les premiers dossiers
                                    "disabled": false,
                                    "selected": false
                                },
                                "children": this._buildTree(data[key][_i], id ? id + "_" + key + '_' + _i : key + '_' + _i)
                            });
                            count++;
                        }
                    } else {
                        obj.push({
                            "id": (id ? id + "_" + key : key).replace(/@/g, ':at:'),
                            "text": key,
                            "icon": key.indexOf('@') === 0 ? "jstree-attr" : "jstree-folder",
                            "state": {
                                "opened": (id.match(/_/g) || []).length < this.auto_open_count, // Ouvre les premiers dossiers
                                "disabled": false,
                                "selected": false
                            },
                            "children": this._buildTree(data[key], id ? id + "_" + key : key)
                        });
                        count++;
                    }

                    if (rules && _typeof(rules.elements) === 'object' && _typeof(rules.elements[key]) === 'object' && (rules.elements[key].maxOccurs === 'unbounded' || count < parseInt(rules.elements[key].maxOccurs, 10))) {
                        obj.push({
                            "id": count > 0 ? id + "_" + key + '_' + count : id + "_" + key,
                            "text": key,
                            "icon": "jstree-add-folder",
                            "state": {
                                "opened": false,
                                "disabled": false,
                                "selected": false
                            }
                        });
                    }
                }
            }
            return obj;
        }

        /**
         * Permet d'obtenir un lien (info) pour afficher la doc
         * @param {string} id
         * @returns {*|void|jQuery}
         * @private
         */

    }, {
        key: '_buildForm',


        /**
         * Permet de créer le formulaire de modification d'un noeud
         *
         * @param {string} id
         */
        value: function _buildForm(id) {
            var that = this,
                path = id.replace(/:at:/g, '@').split('_'),
                title = (!AsalaeGlobal.is_numeric(path[path.length - 1]) ? path[path.length - 1] : path[path.length - 2]).replace(/:at:/g, '@'),
                table = $('<table class="table table-striped table-hover minifiable-target"></table>'),
                data = XsdForm._getDataByPath(this.data, path),
                rules = id.indexOf('_:at:') > 0 ? this._getRulesById(id.substr(0, id.indexOf('_:at:'))) : this._getRulesById(id),
                filteredPath = id.replace(/:at:/g, '@').split('_').filter(function (a) {
                return !AsalaeGlobal.is_numeric(a) && a.length > 0;
            });
            this.form.empty().append($('<h2>' + title + '</h2>'));
            this.form.append(this._appendAriane(id));

            // Si attribut
            if (path[path.length - 1][0] === '@') {
                var dataName = '@',
                    value = typeof data[dataName] !== 'undefined' ? data[dataName] : '',
                    input = Form.input(dataName, {
                    id: id + '_value',
                    name: id + '_value',
                    label: filteredPath[filteredPath.length - 1],
                    value: value,
                    fullname: id
                });
                input.find('input').change(function () {
                    that._setDataById(id, $(this).val());
                });
                this.form.append(input);
                $(XsdForm._getInfoLink(id)).insertBefore(input.find('label'));
                return;
            }

            if (!rules || rules.content !== 'element-only') {
                var _input = this._renderValue(id, data, rules);

                this.form.append(_input).append('<hr>');
                $(XsdForm._getInfoLink(id)).insertBefore(_input.find('label'));
            } else if (rules.attributes) {
                var list = $('<div class="attributesList"></div>');

                var _loop = function _loop(key) {
                    // m.id/localType => @localType || xml:id => @xml:id
                    var baseName = key.substr(key.lastIndexOf('/') + 1),
                        dataName = '@' + baseName,
                        idName = id + '_' + ':at:' + baseName,
                        value = typeof data[dataName] !== 'undefined' ? data[dataName] : '',
                        input = Form.input(dataName, {
                        id: idName + '_value',
                        name: idName + '_value',
                        value: value,
                        fullname: idName
                    });
                    input.find('input').change(function () {
                        that._setDataById(idName, $(this).val());
                    });
                    $(XsdForm._getInfoLink(idName)).insertBefore(input.find('label'));
                    list.append(input);
                };

                for (var key in rules.attributes) {
                    _loop(key);
                }
                this.form.append(list).append('<hr>');
            }

            if (rules) {
                for (var key in rules.elements) {
                    var subId = id + '_' + key,
                        subRules = this._getRulesById(subId);
                    if (subRules.content !== 'element-only') {
                        var subPath = path.slice();
                        subPath.push(key);
                        var _input2 = this._renderValue(subId, XsdForm._getDataByPath(this.data, subPath), subRules);
                        this.form.append(_input2);
                        $(XsdForm._getInfoLink(subId)).insertBefore(_input2.find('label'));
                    }
                }
            } else {
                for (var _key in data) {
                    if (_key[0] !== '@') {
                        var _subId = id + '_' + _key,
                            _subPath = path.slice();
                        _subPath.push(_key);
                        var _input3 = this._renderValue(_subId, XsdForm._getDataByPath(this.data, _subPath), false);
                        this.form.append(_input3);
                    }
                }
            }

            this.doc.html(XsdForm._getDocById(id));
        }

        /**
         * Handler permettant de charger/afficher/cacher la liste d'attributs
         * @param {object} event
         * @param {string} id
         * @param {string} attributes
         */

    }, {
        key: 'toggleAttributes',
        value: function toggleAttributes(event, id, attributes) {
            event.preventDefault();
            var container = $(event.target).closest('div.form-group'),
                path = id.replace(/:at:/g, '@').split('_'),
                data = XsdForm._getDataByPath(this.data, path),
                attributes = JSON.parse(attributes),
                list = container.find('.attributesList'),
                that = this;
            if (list.length > 0) {
                list.slideToggle();
            } else {
                list = $('<div class="attributesList" style="display: none;"></div>');

                var _loop2 = function _loop2(key) {
                    // m.id/localType => @localType || xml:id => @xml:id
                    var baseName = key.substr(key.lastIndexOf('/') + 1),
                        dataName = '@' + baseName,
                        idName = id + '_' + ':at:' + baseName,
                        value = data && typeof data[dataName] !== 'undefined' ? data[dataName] : '',
                        input = Form.input(dataName, {
                        id: idName + '_value',
                        name: idName + '_value',
                        value: value,
                        fullname: idName
                    });
                    input.find('input').change(function () {
                        that._setDataById(idName, $(this).val());
                    });
                    list.append(input);
                };

                for (var key in attributes) {
                    _loop2(key);
                }
                container.append(list);
                list.slideDown();
            }
        }

        /**
         * Permet d'obtenir le label, qui comporte les attributs du champ si besoin
         * @param {string} id
         * @param {object} data
         * @param {object} rules
         * @private
         */

    }, {
        key: '_getAttributesIcon',
        value: function _getAttributesIcon(id, data, rules) {
            if (rules.attributes && Object.keys(rules.attributes).length > 0) {
                var instance = 'XsdForm.instance[' + this.instanceIndex + ']',
                    title = XsdForm.texts.toggleAttributesTitle,
                    dataString = JSON.stringify(data).replace(/(")/g, '\\$1').replace(/'/g, '&quote;').replace(/\\([ntr])/g, '\\\\$1'),
                    ruleAttrString = JSON.stringify(rules.attributes).replace(/(")/g, '\\$1');

                return '<a href="javascript:" onclick=\'' + instance + '.toggleAttributes(event, \"' + id + '\", \"' + ruleAttrString + '\")\' title="' + title + '" role="button"> <i class="fa fa-tags" aria-hidden="true"></i><span class="sr-only">' + title + '</span></a>';
            } else {
                return '';
            }
        }

        /**
         * Effectue le rendu HTML de la valeur
         * @param {string} id
         * @param {object} data
         * @param {object} rules
         * @private
         */

    }, {
        key: '_renderValue',
        value: function _renderValue(id, data, rules) {
            var that = this,
                output;
            if (typeof data === 'undefined') {
                data = { '@': '' };
            }
            if (Array.isArray(data)) {
                var group = $('<div class="multi-value-group"></div>');
                for (var _i2 = 0; _i2 < data.length; _i2++) {
                    group.append(this._renderValue(id + '_' + _i2, data[_i2], rules));
                }
                return group;
            }

            if (!rules) {
                var filteredId = id.replace(/:at:/g, '@').split('_').filter(function (a) {
                    return !AsalaeGlobal.is_numeric(a) && a.length > 0;
                }).join('_');
                rules = {
                    attributes: {},
                    traduction: filteredId.substr(filteredId.lastIndexOf('_') + 1),
                    enumeration: []
                };
                for (var key in data) {
                    if (key[0] === '@' && key.length > 1) {
                        rules.attributes[key.substr(1)] = { use: 'optional' };
                    }
                }
            }

            // Select de la valeur
            if (rules.enumeration.length > 0) {
                var enumeration = {};
                for (var _i3 = 0; _i3 < rules.enumeration.length; _i3++) {
                    enumeration[rules.enumeration[_i3]] = rules.enumeration[_i3];
                }
                var select = Form.select(rules.traduction, {
                    id: id + '_value',
                    name: id + '_value',
                    label: rules.traduction,
                    value: data['@'],
                    fullname: id,
                    options: enumeration
                });
                select.find('select').change(function () {
                    that._setDataById(id + '_@', $(this).val());
                });
                $(this._getAttributesIcon(id, data, rules)).insertAfter(select.find('label'));
                output = select;

                // Saisie manuelle de la valeur
            } else {
                var textarea = Form.textarea(rules.traduction, {
                    id: id + '_value',
                    name: id + '_value',
                    label: rules.traduction,
                    value: data && data['@'] ? data['@'] : '',
                    fullname: id
                });
                textarea.find('textarea').change(function () {
                    that._setDataById(id + '_@', $(this).val());
                });
                $(this._getAttributesIcon(id, data, rules)).insertAfter(textarea.find('label'));
                output = textarea;
            }

            return output;
        }

        /**
         * Récupère la documentation dans la page si elle existe sous le terme
         * data-id="elementName"
         * @param {string} id
         * @returns {jQuery}
         * @private
         */

    }, {
        key: '_getDataById',


        /**
         * Permet d'obtenir la/les valeur(s) selon un id donné
         *
         * @param {string} id
         * @param {string} mask
         * @returns {object|string}
         */
        value: function _getDataById(id) {
            var mask = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '_';

            return XsdForm._getDataByPath(this.data, id.split(mask));
        }

        /**
         * Permet de modifier la valeur selon un id donné
         *
         * @param {string} id
         * @param {string|object} value
         * @returns {XsdForm}
         */

    }, {
        key: '_setDataById',
        value: function _setDataById(id, value) {
            var that = this,
                path = id.replace(/:at:/g, '@').split('_'),
                evalString = 'that.data',
                evalParent = 'that.data',
                hasChanged = false,
                testedVar = this.data;

            // Assure l'existance de la donné parente
            for (var _i4 = 0; _i4 < path.length; _i4++) {
                var defaultValue = path[_i4][0] === '@' ? '' : {};
                evalString += '["' + path[_i4] + '"]';
                eval('if (typeof ' + evalString + ' === "undefined") { ' + evalString + ' = defaultValue; hasChanged = true; }');
                if (_i4 + 1 < path.length) {
                    evalParent = evalString;
                }
            }
            if (value === '') {
                this._unsetById(id);
                hasChanged = true;
            } else {
                eval(evalString + " = value");
            }
            if (hasChanged) {
                this.update();
            }
            $(this).trigger('data_changed');
            return this;
        }

        /**
         * Supprime une valeur en fonction de son id
         * @param {string} id
         */

    }, {
        key: '_unsetById',
        value: function _unsetById(id) {
            var that = this,
                path = id.replace(/:at:/g, '@').split('_'),
                fullPath = path.slice(),
                last = path.pop(),
                beforeLast = path.pop(),
                data = eval('that.data["' + path.join('"]["') + '"]');

            // Cas de suppression d'un argument/valeur dans element multiple (array)
            if (last[0] === '@' && Array.isArray(data) && _typeof(data[beforeLast]) === 'object' && Object.keys(data[beforeLast]).length === 1) {
                eval('that.data["' + path.join('"]["') + '"].splice(' + beforeLast + ', 1)');
            } else if (_typeof(data[beforeLast]) === 'object' && Object.keys(data[beforeLast]).length === 1) {
                eval('delete that.data["' + path.join('"]["') + '"]["' + beforeLast + '"]');
            } else {
                eval('delete that.data["' + fullPath.join('"]["') + '"]');
            }
        }

        /**
         * Initialize un noeud
         * @param {string} id
         * @private
         */

    }, {
        key: '_createNode',
        value: function _createNode(id) {
            var that = this,
                path = id.replace(/:at:/g, '@').split('_'),
                match = id.match(/^(.*)_[\d]+$/);
            if (match) {
                var data = this._getDataById(match[1]),
                    evalString = match[1].replace(/_/g, "']['");
                if (Array.isArray(data)) {
                    eval("that.data['" + evalString + "'].push({})");
                } else {
                    eval("that.data['" + evalString + "'] = [data, {}]");
                }
            } else {
                console.warn("cas particulier : tentative de création de l'id " + id);
            }
            this.update();
            this.jstree.on('loaded.jstree', function () {
                that.openNode(id.split('_').slice(0, -1));
            });
        }

        /**
         * Ouvre un noeud avec tout ses parents
         * @param {array} path
         */

    }, {
        key: 'openNode',
        value: function openNode(path) {
            var targetPath = [],
                id = '',
                jstree = this.jstree.find('> .jstree');
            for (var _i5 = 0; _i5 < path.length; _i5++) {
                targetPath.push(path[_i5]);
                id = '#' + targetPath.join('_');
                if ($(id).hasClass('jstree-closed')) {
                    jstree.jstree('open_node', id);
                }
            }
            jstree.jstree('select_node', id);
        }

        /**
         * Action qui permet de retirer une valeur
         *
         * @param {string} id Identifiant de l'element à retirer
         * @param {number} instance Numéro de l'instance de classe (XsdForm.instance[instance])
         */

    }, {
        key: '_genAddBtn',


        /**
         * Génère le bouton qui permet d'ajouter une valeur
         *
         * @returns {jQuery}
         */
        value: function _genAddBtn() {
            var that = this;
            return $('<button type="button">' + XsdForm.texts.add + '</button>').click(function () {
                var select = $(this).parent().find('select'),
                    values = select.val(),
                    target = select.attr('data-fullname');
                if (!Array.isArray(values) || values.length < 1) {
                    return;
                }
                for (var _i6 = 0; _i6 < values.length; _i6++) {
                    that._addElementToTargetId(values[_i6], target);
                }
                that.update();
                $('.jstree').one("loaded.jstree", function () {
                    $(this).jstree('select_node', target);
                });
            });
        }
    }, {
        key: '_genDocBtn',
        value: function _genDocBtn() {
            var that = this;
            return $('<button type="button" title="' + XsdForm.texts.doc + '"><i aria-hidden="true" class="fa fa-info-circle"></i></button>').click(function () {
                var select = $(this).parent().find('select'),
                    values = select.val(),
                    target = select.attr('data-fullname');
                if (!Array.isArray(values) || values.length < 1) {
                    return;
                }
                XsdForm.viewdocCallback(values[0]);
            });
        }

        /**
         * Permet d'obtenir les règles d'un element en fonction de son identifiant
         * ex: eac-cpf.cpfDescription.identity.nameEntry renverra this.xsd.elements['identity/nameEntry'] (cas spécial)
         * ex: eac-cpf.cpfDescription renverra this.xsd.elements['cpfDescription'] (cas normal)
         * @param {string} id
         * @returns {object|bool}
         */

    }, {
        key: '_getRulesById',
        value: function _getRulesById(id) {
            var pointer = 0,
                rules = false,
                that = this,
                path = id.replace(/:at:|@/g, '').split('_').filter(function (a) {
                return !AsalaeGlobal.is_numeric(a) && a.length > 0;
            });
            for (var _i7 = 0; _i7 < path.length; _i7++) {
                var t = [];
                for (var j = _i7; j < path.length; j++) {
                    t.push(path[j]);
                }
                try {
                    rules = eval("that.xsd.elements['" + t.join('/') + "']");
                } catch (e) {
                    rules = false;
                }
                if (rules) {
                    break;
                }
            }
            return rules;
        }

        /**
         * Génère le select qui permet d'ajouter des elements dand un element
         *
         * @param {string} id
         * @returns {jquery}
         */

    }, {
        key: '_selectAppendChild',
        value: function _selectAppendChild(id) {
            var rules = this._getRulesById(id),
                options = {},
                select,
                data = this._getDataById(id);

            if (rules) {
                var possibleOptions = rules.elements;
                for (var key in possibleOptions) {
                    var max = possibleOptions[key].maxOccurs,
                        count = XsdForm._countSpecificChildNodes(data, key);
                    if (!AsalaeGlobal.is_numeric(max)) {
                        max = Infinity;
                    }
                    if (count < max && XsdForm._canAddChoosableElement(data, key, rules) && this.blackList.indexOf(key) === -1) {
                        options[key] = key;
                    }
                }
                possibleOptions = rules.attributes;
                for (var _key2 in possibleOptions) {
                    var _count = XsdForm._countSpecificChildNodes(data, _key2);
                    if (_count === 0) {
                        options['@' + _key2] = '@' + _key2;
                    }
                }
            }

            select = Form.select(XsdForm.texts.add, {
                id: id + '_select_add',
                fullname: id,
                options: options,
                multiple: true
            });
            select.append(this._genDocBtn());
            select.append(this._genAddBtn());
            return select;
        }

        /**
         * Donne le nombre de nodeName que contient data selon les deux possibilités
         * de structure :
         * data = [{nodeName: 'foo'}, {nodeName: 'bar'}] -> count 2 (data[i].nodeName)
         * data = {nodeName: 'foo', bar: 'baz'} -> count 1 (data.nodeName)
         *
         * @param {Array|object} data
         * @param {string} nodeName
         * @returns {Number}
         */

    }, {
        key: '_addElementToTargetId',


        /**
         * Ajoute un element (value) dans le chemin (target) de this.data
         * Se base sur les règles xsd pour la position.
         *
         * @param {string} value
         * @param {string} target
         */
        value: function _addElementToTargetId(value, target) {
            var rules = this._getRulesById(target),
                data = this._getDataById(target),
                newData = data,
                dataKeys = Object.keys(data),
                sequence = rules.sequence.length > 0 ? rules.sequence : null,
                index = sequence ? sequence.indexOf(value) : -1,
                insertAfter = dataKeys ? dataKeys[dataKeys.length - 1] : '',
                nameToInsert = value.lastIndexOf('/') ? value.substr(value.lastIndexOf('/') + 1) : value;
            if (value[0] === '@' && nameToInsert[0] !== '@') {
                nameToInsert = '@' + nameToInsert;
            }
            index--;
            if (typeof data === 'string') {
                data = data ? { '@': data } : {};
                dataKeys = Object.keys(data);
                insertAfter = dataKeys ? dataKeys[dataKeys.length - 1] : '';
            }
            if (typeof data[nameToInsert] !== 'undefined') {
                if (!Array.isArray(data[nameToInsert])) {
                    data[nameToInsert] = [data[nameToInsert], ''];
                } else {
                    data[nameToInsert].push('');
                }
            } else if (index === -1) {
                data = XsdForm._prependValue(data, nameToInsert, "");
            } else {
                while (index > -1) {
                    if (dataKeys.indexOf(sequence[index]) !== -1) {
                        insertAfter = sequence[index];
                        break;
                    }
                    index--;
                }
                if (insertAfter) {
                    data = XsdForm._insertAfter(data, insertAfter, nameToInsert, '');
                } else {
                    data[value] = '';
                }
            }
            this._insertDataById(data, target);
        }

        /**
         * Remplace les données dans le chemin id par data
         * @param {object|string} data
         * @param {string} id
         */

    }, {
        key: '_insertDataById',
        value: function _insertDataById(data, id) {
            var that = this;
            eval("that.data['" + id.replace(/_/g, "']['") + "'] = data");
        }

        /**
         * Génère un fil d'ariane en fonction de id
         * @param {string} id
         * @returns {jQuery}
         */

    }, {
        key: '_appendAriane',
        value: function _appendAriane(id) {
            var path = id.replace(/([a-z0-9]+)_([\d]+)/gi, '$1:i:$2').split('_'),
                units = [];
            for (var _i8 = 0; _i8 < path.length - 1; _i8++) {
                var target = [];
                for (var j = 0; j <= _i8; j++) {
                    target.push(path[j]);
                }
                var _label = path[_i8].replace(/:at:/g, '@').replace(/([\w]+):i:([\d]+)/g, '$1_$2'),
                    _match = _label.match(/_[\d]+$/g);
                if (_match) {
                    _match[0] = _match[0].substr(1);
                    _label = _label.substr(0, _label.length - _match[0].length - 1) + ' ' + (parseInt(_match[0], 10) + 1);
                }

                units.push({
                    href: "javascript:XsdForm.openCallback('" + target.join('_').replace(/([\w]+):i:([\d]+)/g, '$1_$2') + "', " + this.instanceIndex + ")",
                    role: "button",
                    label: _label
                });
            }
            var label = path[path.length - 1].replace(/:at:/g, '@').replace(/([\w]+):i:([\d]+)/g, '$1_$2'),
                match = label.match(/_[\d]+$/g);
            if (match) {
                match[0] = match[0].substr(1);
                label = label.substr(0, label.length - match[0].length - 1) + ' ' + (parseInt(match[0], 10) + 1);
            }
            units.push({ label: label });
            return Form.ariane(units);
        }

        /**
         * Permet d'obtenir la valeur d'un element pour affichage dans le tableau
         * @param {string|object} data
         * @returns {string}
         */

    }], [{
        key: '_format',
        value: function _format(data) {
            if ((typeof data === 'undefined' ? 'undefined' : _typeof(data)) === 'object') {
                for (var key in data) {
                    if (_typeof(data[key]) === 'object') {
                        data[key] = XsdForm._format(data[key]);
                    } else if (typeof data[key] === 'string' && key[0] !== '@') {
                        data[key] = { '@': data[key] };
                    }
                }
            }
            return data;
        }

        /**
         * Permet de visualiser l'ordre d'execution des nombreux évenements de jstree
         * @param {jQuery} element
         * @return {jQuery} element
         */

    }, {
        key: 'debugJstreeEvents',
        value: function debugJstreeEvents(element) {
            var test = ['init', 'loading', 'loaded', 'changed', 'ready', 'load_node', 'model', 'redraw', 'before_open', 'after_open', 'open_node', 'after_close', 'close_node', 'open_all', 'close_all', 'enable_node', 'disable_node', 'activate_node', 'hover_node', 'dehover_node', 'select_node', 'deselect_node', 'select_all', 'deselect_all', 'set_table', 'refresh', 'refresh_state', 'set_next', 'create_node', 'rename_node', 'delete_node', 'move_node', 'copy_node', 'cut', 'copy', 'paste', 'set_theme', 'show_contextmenu', 'show', 'hide', 'mousedown', 'scroll', 'start', 'move', 'stop', 'search', 'clear_search', 'restore_search', 'click', 'dblclick', 'keydown', 'focus', 'mouseenter', 'mouseleave'];

            var _loop3 = function _loop3(_i9) {
                $(element).on(test[_i9], function () {
                    console.info(test[_i9]);
                });
                $(element).on(test[_i9] + '.jstree', function () {
                    console.info(test[_i9] + '.jstree');
                });
            };

            for (var _i9 = 0; _i9 < test.length; _i9++) {
                _loop3(_i9);
            }
            return element;
        }
    }, {
        key: '_getInfoLink',
        value: function _getInfoLink(id) {
            var filteredPath = id.replace(/:at:/g, '@').split('_').filter(function (a) {
                return !AsalaeGlobal.is_numeric(a) && a.length > 0;
            });
            var targetDoc = filteredPath.pop();
            if (targetDoc === '@') {
                targetDoc = filteredPath.pop();
            }
            if ($('[data-id="' + targetDoc + '"]').length === 0) {
                return '';
            }
            return XsdForm._getDocById(id) ? $('<a href="javascript:" title="' + XsdForm.texts.doc + '" role="button"><i aria-hidden="true" class="fa fa-info-circle"></i> </a>').append('<span class="sr-only">' + XsdForm.texts.doc + '</span>').click(function () {
                var focused = $('*:focus');
                $(this).closest('.modal').append(XsdForm.viewdocCallback(id));
                $('.doc-tooltip .close').focus().click(function () {
                    focused.focus();
                });
            }) : '';
        }
    }, {
        key: '_getDocById',
        value: function _getDocById(id) {
            var filteredPath = id.replace(/:at:/g, '@').split('_').filter(function (a) {
                return !AsalaeGlobal.is_numeric(a) && a.length > 0;
            });
            var targetDoc = filteredPath.pop();
            if (targetDoc === '@') {
                targetDoc = filteredPath.pop();
            }
            return $('[data-id="' + targetDoc + '"]').html();
        }

        /**
         * Permet d'obenir le contenu de data à partir d'un chemin sous forme d'array
         * Ex : si path == ['foo', 'bar'], alors on retourne data.foo.bar
         *
         * @param {object} data
         * @param {Array} path
         * @returns {object|string}
         */

    }, {
        key: '_getDataByPath',
        value: function _getDataByPath(data, path) {
            var newData = eval("data['" + path.join("']['") + "']");
            if (typeof newData === 'string') {
                newData = { "@": newData };
            }
            return newData;
        }
    }, {
        key: 'removeCallback',
        value: function removeCallback(id, instance) {
            var mainId = id.substr(0, id.lastIndexOf('_')),
                index = id.substr(id.lastIndexOf('_') + 1),
                targetData = "XsdForm.instance[" + instance + "].data['" + mainId.replace(/_/g, "']['") + "']",
                data = eval(targetData);
            if (confirm(XsdForm.texts.removeConfirm)) {
                if (data.length > 1 && Array.isArray(data)) {
                    eval(targetData + '.splice(' + index + ', 1)');
                } else {
                    eval('delete ' + targetData);
                }
                XsdForm.instance[instance].jstree.one("loaded.jstree", function () {
                    XsdForm.openCallback(mainId.substr(0, mainId.lastIndexOf('_')), instance);
                });
                XsdForm.instance[instance].update();
            }
        }

        /**
         * Action qui permet de consulter une valeur
         *
         * @param {string} id Identifiant de l'element à consulter
         * @param {number} instance Numéro de l'instance de classe (XsdForm.instance[instance])
         */

    }, {
        key: 'openCallback',
        value: function openCallback(id, instance) {
            var jstree = $('.jstree');
            id = id.replace(/@/g, ':at:');
            jstree.jstree('deselect_all');
            if (AsalaeGlobal.is_numeric(id.substr(id.lastIndexOf('_') + 1))) {
                jstree.jstree('select_node', id.substr(0, id.lastIndexOf('_')));
            }
            jstree.jstree('select_node', id);
        }

        /**
         * Affiche une fenetre avec la documentation de l'element choisi
         * @param {string} id
         */

    }, {
        key: 'viewdocCallback',
        value: function viewdocCallback(id) {
            var docWindow = $('<div class="bg-white doc-tooltip"></div>').append($('<div class="handle"></div>').append($('<a class="close" href="#"><span aria-hidden="true">&times;</span><span class="sr-only">' + XsdForm.texts.close + '</span></a>').click(function (event) {
                event.preventDefault();
                $('.doc-tooltip').remove();
            }))).append($('<div class="content"></div>').append(XsdForm._getDocById(id))).append($('<div class="bottom-handle"></div>').css('cursor', 'move')).draggableCustom({
                handle: ".handle, .bottom-handle"
            }).css({ position: 'fixed', 'z-index': 1000000, 'max-height': 600, top: 50, left: 50, right: 50, bottom: 50 });
            $(window).off('keydown.tooltip').on('keydown.tooltip', function (event) {
                if (event.originalEvent.keyCode === 27) {
                    // Escape
                    $('.doc-tooltip').remove();
                }
            });
            $('.doc-tooltip').remove();
            return docWindow;
        }
    }, {
        key: '_countSpecificChildNodes',
        value: function _countSpecificChildNodes(data, nodeName) {
            var count = 0;
            nodeName = nodeName.indexOf('/') ? nodeName.substr(nodeName.lastIndexOf('/') + 1) : nodeName;
            for (var key in data) {
                if (key.replace('@', '') === nodeName || typeof data[key][nodeName] !== 'undefined' || data[key] === nodeName) {
                    count++;
                }
            }
            return count;
        }

        /**
         * Si l'element fait parti d'un choix, le choix ne doit pas avoir été fait
         * au préalable.
         * Ex: si on a le choix entre foo et bar, et qu'on veut ajouter bar, il faut
         * que ni foo, ni bar ne soit présent
         *
         * @param {object} data
         * @param {string} nodeName
         * @param {object} rules
         * @returns {bool}
         */

    }, {
        key: '_canAddChoosableElement',
        value: function _canAddChoosableElement(data, nodeName, rules) {
            var compatible = true;
            if (typeof rules.choice === 'undefined') {
                return true;
            }
            for (var _i10 = 0, c = rules.choice.length; _i10 < c; _i10++) {
                if (rules.choice[_i10].indexOf(nodeName) === -1) {
                    continue;
                }
                for (var j = 0; j < rules.choice[_i10].length; j++) {
                    if (XsdForm._countSpecificChildNodes(data, rules.choice[_i10][j]) > 0) {
                        compatible = false;
                        break;
                    }
                }
                if (!compatible) {
                    break;
                }
            }
            return compatible;
        }

        /**
         * Permet d'insérer précisement une valeur après une autre
         * Ex: on veux insérer la clef bar entre foo et baz :
         * XsdForm._insertAfter({foo: 1, baz: 1}, 'foo', 'bar', 1)
         *          -> résultat : {foo: 1, bar: 1, baz: 1}
         *
         * @param {object} data
         * @param {string} insertAfterThisKey
         * @param {string} newKey
         * @param {string|object} newValue
         * @returns {object}
         */

    }, {
        key: '_insertAfter',
        value: function _insertAfter(data, insertAfterThisKey, newKey, newValue) {
            var newData = {};
            for (var key in data) {
                newData[key] = data[key];
                if (key === insertAfterThisKey) {
                    newData[newKey] = newValue;
                }
            }
            return newData;
        }

        /**
         * Ajoute une valeur au début d'un objet
         *
         * @param {object} data
         * @param {string} newKey
         * @param {string|object} newValue
         * @returns {object}
         */

    }, {
        key: '_prependValue',
        value: function _prependValue(data, newKey, newValue) {
            var newData = {};
            newData[newKey] = newValue;
            for (var key in data) {
                newData[key] = data[key];
            }
            return newData;
        }
    }, {
        key: 'getValue',
        value: function getValue(data) {
            if (typeof data === 'string') {
                return data;
            }
            if (data['@']) {
                return data['@'];
            }
        }

        /**
         * Permet d'obtenir la valeur d'un element pour affichage dans le tableau
         * @param {string|object} data
         * @returns {string}
         */

    }, {
        key: 'getElements',
        value: function getElements(data) {
            var ul = $('<ul></ul>');
            if (typeof data === 'string') {
                return;
            }
            for (var key in data) {
                if (key.indexOf('@') !== 0) {
                    ul.append('<li>' + key + '</li>');
                }
            }
            return ul;
        }

        /**
         * Permet d'obtenir la valeur d'un element pour affichage dans le tableau
         * @param {string|object} data
         * @returns {string}
         */

    }, {
        key: 'getArgs',
        value: function getArgs(data) {
            var ul = $('<ul></ul>');
            if (typeof data === 'string') {
                return;
            }
            for (var key in data) {
                if (key.indexOf('@') === 0 && key !== '@') {
                    ul.append('<li>' + key.substr(1) + ' : ' + data[key] + '</li>');
                }
            }
            return ul;
        }
    }]);

    return XsdForm;
}();

XsdForm.texts = {
    value: 'Valeur',
    attribute: 'Attribut',
    element: 'Element',
    elements: 'Elements',
    args: 'Arguments',
    add: 'Ajouter',
    viewTitle: 'Voir documentation',
    doc: 'Documentation',
    openTitle: 'Ouvrir',
    removeTitle: 'Retirer valeur',
    removeConfirm: "Cette action va retirer les valeurs contenu dans l'element, Voulez-vous continuer ?",
    toggleAttributesTitle: "Afficher/Cacher les attributs",
    close: 'Fermer'
};

//# sourceMappingURL=asalae.ruletoform-compiled.js.map